#!/bin/bash

# default GW from eth0 
GATEWAY=`/sbin/ip route |grep '^default' | awk '/eth0/ {print $3}'`

# Add eth2 interface config if missing
echo "GATEWAY=$GATEWAY" >> /etc/sysconfig/network

# Download jq cmd from github
command -v jq > /dev/null \
|| ( curl -L https://github.com/stedolan/jq/releases/download/jq-1.5/jq-linux64 -o /usr/bin/jq \
&& chmod +x /usr/bin/jq )

# Get meta-data from openstack to check all network ips
[ ! -f "/tmp/network_data.json" ] && curl http://169.254.169.254/openstack/2016-10-06/network_data.json -o /tmp/network_data.json 
IPS=$(cat /tmp/network_data.json | jq  '.networks[].ip_address')

# Iterate over all interfaces
i=0
for ip in $IPS; do
	if [ "$ip" != "null" ] ; then
        echo "Checking static IP $ip for eth$i"
		if [ ! -f "/etc/sysconfig/network-scripts/ifcfg-eth$i" ]; then
			cat <<-EOF >/etc/sysconfig/network-scripts/ifcfg-eth$i
            # Generated by $0
			BOOTPROTO=static
			DEVICE=eth$i
			ONBOOT=yes
			TYPE=Ethernet
			USERCTL=no
			IPADDR=$ip
			NETMASK=255.255.255.0
			EOF
		fi  
	else
        echo "Checking DHCP for eth$i"
		if [ ! -f "/etc/sysconfig/network-scripts/ifcfg-eth$i" ]; then
			cat <<-EOF >/etc/sysconfig/network-scripts/ifcfg-eth$i
            # Generated by $0
			BOOTPROTO=dhcp
			DEVICE=eth$i
			ONBOOT=yes
			TYPE=Ethernet
			USERCTL=no
			EOF
		fi
	fi
    # Brig up the interface
    /usr/sbin/ifup eth$i

	i=$((i+1))
done

# Set default GW to eth0 
ip route del 0/0
ip route add default via $GATEWAY

exit
